#    Copyright (C) 1998, 1999 by Denis Chertykov (denis@overta.ru)
#
#   You can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2, or (at your option)
#   any later version.
#
#   This function send one byte to parallel port
#  Connect AVR with parallel port
#        AVR                       Parallel Port
#   Signal name   Pin             Pin  Signal name
#   GND           20 ------------ 19   GND
#   GND           20 ------------ 21   GND
#   SCK            8 ------------  1   Strobe
#   MOSI           6 ------------ 12   Out of paper
#   MISO           7 ------------ 11   Busy
#   Reset          9 ------------ 16   Init
#   Connect parallel port pin 12 with parallel port pin 2 through diod
#                                 Out of paper 12 ----|>|--- 2 Data 0
#  This connection allow to use send_byte and program AVR flash 
#  with Uros Platise `uisp' in dummy mode.
#
#  Bugs: For me this work only if Parellel port in EPP mode.
#        May be ECP mode also work ?
#        

.arch	avr2

.set	PORTB,  0x18
.set	DDRB,   0x17
.set	PINB,   0x16

.section .text
#	.func	send_byte
.globl	send_byte
send_byte:
	mov	r24,r25
	ldi	r25,0x55
	rcall	send_byte1
	mov	r25,r24

send_byte1:
	ldi	r19,8
send_bloop:
1:	sbic	PINB, 7
	rjmp	1b

	
	sbrc	r25,0
	cbi	PORTB, 6
	sbrs	r25,0
	sbi	PORTB, 6
	
	sbi	PORTB, 5

send_bwait_z:
	sbis	PINB, 7
	rjmp	send_bwait_z
	
	cbi	PORTB, 5

	asr	r25
	dec	r19
	brne	send_bloop
	ret
#	.endfunc
