/* Copyright (C) 1999 by Denis Chertykov (denisc@overta.ru)
   
   You can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program was used for the principal possibility of
   stepping by timer 0
*/

#include <stdio.h>
#include <io8515.h>
#include <signal.h>
#include <interrupt.h>
#include "monitor.h"

#define TIMER0_CK 1

void puts (char *);


volatile unsigned char timer_int_p;

SIGNAL (_overflow0_)
{
  char a[3];
  outp (0,TCCR0);
  asm volatile ("sts timer_int_p, r12");
}

int
main ()
{
  init_send_byte ();
  puts ("T-t");
  outp (TIMER0_CK, TCCR0);
  outp (inp (TIMSK) | BV(TOIE0), TIMSK);
  outp (-6, TCNT0);
  asm ("clr r12");
  asm ("inc r12");
  asm ("inc r12");
  asm ("inc r12");
  asm ("inc r12");
  asm ("inc r12");
  asm ("inc r12");
  asm ("inc r12");
  asm ("inc r12");
  asm ("inc r12");
  asm ("inc r12");
  asm ("inc r12");
  asm ("inc r12");
  asm ("inc r12");
  sei ();
  asm ("nop");
  asm ("inc r12");
  cli ();
  send_byte (timer_int_p);
  if (timer_int_p)
    puts ("Timer interrupt occurs");
  else
    puts ("Not occurs");
  return 0;
}

void
puts (char *s)
{
  send_str (s);
  send_byte ('\n');
}
